/* main-panel-plugin-47.c generated by valac, the Vala compiler
 * generated from main-panel-plugin-47.vala, do not modify */

/*
 *  Notes - panel plugin for Xfce Desktop Environment
 *  Copyright (C) 2009-2010  Mike Massonnet <mmassonnet@xfce.org>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
 */

#include <glib.h>
#include <glib-object.h>
#include <libxfce4panel/libxfce4panel.h>
#include <gtk/gtk.h>
#include <libnotes.h>
#include <libxfce4util/libxfce4util.h>
#include <config.h>
#include <glib/gi18n-lib.h>
#include <popup.h>
#include <gdk/gdk.h>
#include <string.h>


#define TYPE_NOTES_PLUGIN (notes_plugin_get_type ())
#define NOTES_PLUGIN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NOTES_PLUGIN, NotesPlugin))
#define NOTES_PLUGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NOTES_PLUGIN, NotesPluginClass))
#define IS_NOTES_PLUGIN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NOTES_PLUGIN))
#define IS_NOTES_PLUGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NOTES_PLUGIN))
#define NOTES_PLUGIN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NOTES_PLUGIN, NotesPluginClass))

typedef struct _NotesPlugin NotesPlugin;
typedef struct _NotesPluginClass NotesPluginClass;
typedef struct _NotesPluginPrivate NotesPluginPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _NotesPlugin {
	XfcePanelPlugin parent_instance;
	NotesPluginPrivate * priv;
};

struct _NotesPluginClass {
	XfcePanelPluginClass parent_class;
};

struct _NotesPluginPrivate {
	GtkInvisible* invisible;
	GtkButton* button;
	XfcePanelImage* image;
	XnpApplication* application;
};


static gpointer notes_plugin_parent_class = NULL;
static GType notes_plugin_type_id = 0;

GType notes_plugin_get_type (void);
GType notes_plugin_register_type (GTypeModule * module);
#define NOTES_PLUGIN_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_NOTES_PLUGIN, NotesPluginPrivate))
enum  {
	NOTES_PLUGIN_DUMMY_PROPERTY
};
NotesPlugin* notes_plugin_new (void);
NotesPlugin* notes_plugin_construct (GType object_type);
static void _lambda0_ (NotesPlugin* self);
static void __lambda0__gtk_button_clicked (GtkButton* _sender, gpointer self);
static gboolean notes_plugin_set_x_selection (NotesPlugin* self);
static gboolean _lambda2_ (NotesPlugin* p, gint size, NotesPlugin* self);
static gboolean __lambda2__xfce_panel_plugin_size_changed (NotesPlugin* _sender, gint size, gpointer self);
static void _lambda3_ (NotesPlugin* self);
static void __lambda3__xfce_panel_plugin_save (NotesPlugin* _sender, gpointer self);
static void _lambda4_ (NotesPlugin* self);
static void __lambda4__xfce_panel_plugin_free_data (NotesPlugin* _sender, gpointer self);
static void _lambda5_ (NotesPlugin* self);
static void __lambda5__xfce_panel_plugin_configure_plugin (NotesPlugin* _sender, gpointer self);
static void _lambda6_ (NotesPlugin* self);
static void __lambda6__xfce_panel_plugin_about (NotesPlugin* _sender, gpointer self);
static void _lambda7_ (NotesPlugin* self);
static void __lambda7__gtk_object_destroy (NotesPlugin* _sender, gpointer self);
static void notes_plugin_real_construct (XfcePanelPlugin* base);
static gboolean _lambda1_ (GtkInvisible* w, GdkEventClient* event, NotesPlugin* self);
static gboolean __lambda1__gtk_widget_client_event (GtkInvisible* _sender, GdkEventClient* event, gpointer self);
static void notes_plugin_finalize (GObject* obj);
GType xfce_panel_module_init (GTypeModule* module);
static int _vala_strcmp0 (const char * str1, const char * str2);



NotesPlugin* notes_plugin_construct (GType object_type) {
	NotesPlugin * self;
	self = (NotesPlugin*) g_object_new (object_type, NULL);
	return self;
}


NotesPlugin* notes_plugin_new (void) {
	return notes_plugin_construct (TYPE_NOTES_PLUGIN);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void _lambda0_ (NotesPlugin* self) {
	xnp_application_show_hide_notes (self->priv->application);
}


static void __lambda0__gtk_button_clicked (GtkButton* _sender, gpointer self) {
	_lambda0_ (self);
}


static gboolean _lambda2_ (NotesPlugin* p, gint size, NotesPlugin* self) {
	gboolean result;
	g_return_val_if_fail (p != NULL, FALSE);
	gtk_widget_set_size_request ((GtkWidget*) self->priv->button, size, size);
	result = TRUE;
	return result;
}


static gboolean __lambda2__xfce_panel_plugin_size_changed (NotesPlugin* _sender, gint size, gpointer self) {
	return _lambda2_ (_sender, size, self);
}


static void _lambda3_ (NotesPlugin* self) {
	xnp_application_save_windows_configuration (self->priv->application);
}


static void __lambda3__xfce_panel_plugin_save (NotesPlugin* _sender, gpointer self) {
	_lambda3_ (self);
}


static void _lambda4_ (NotesPlugin* self) {
	xnp_application_save_windows_configuration (self->priv->application);
	xnp_application_save_notes (self->priv->application);
}


static void __lambda4__xfce_panel_plugin_free_data (NotesPlugin* _sender, gpointer self) {
	_lambda4_ (self);
}


static void _lambda5_ (NotesPlugin* self) {
	xnp_application_open_settings_dialog (self->priv->application);
}


static void __lambda5__xfce_panel_plugin_configure_plugin (NotesPlugin* _sender, gpointer self) {
	_lambda5_ (self);
}


static void _lambda6_ (NotesPlugin* self) {
	xnp_application_open_about_dialog (self->priv->application);
}


static void __lambda6__xfce_panel_plugin_about (NotesPlugin* _sender, gpointer self) {
	_lambda6_ (self);
}


static void _lambda7_ (NotesPlugin* self) {
	gtk_main_quit ();
}


static void __lambda7__gtk_object_destroy (NotesPlugin* _sender, gpointer self) {
	_lambda7_ (self);
}


static void notes_plugin_real_construct (XfcePanelPlugin* base) {
	NotesPlugin * self;
	XnpApplication* _tmp0_;
	GtkButton* _tmp1_;
	XfcePanelImage* _tmp2_;
	GtkMenuItem* mi;
	GtkMenu* menu;
	self = (NotesPlugin*) base;
	xfce_textdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR, NULL);
	self->priv->application = (_tmp0_ = xnp_application_new (xfce_panel_plugin_save_location ((XfcePanelPlugin*) self, TRUE)), _g_object_unref0 (self->priv->application), _tmp0_);
	self->priv->button = (_tmp1_ = _g_object_ref0 (xfce_panel_create_button ()), _g_object_unref0 (self->priv->button), _tmp1_);
	self->priv->image = (_tmp2_ = g_object_ref_sink (xfce_panel_image_new_from_source ("xfce4-notes-plugin")), _g_object_unref0 (self->priv->image), _tmp2_);
	gtk_container_add ((GtkContainer*) self->priv->button, (GtkWidget*) self->priv->image);
	g_signal_connect_object (self->priv->button, "clicked", (GCallback) __lambda0__gtk_button_clicked, self, 0);
	gtk_widget_show_all ((GtkWidget*) self->priv->button);
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) self->priv->button);
	xfce_panel_plugin_add_action_widget ((XfcePanelPlugin*) self, (GtkWidget*) self->priv->button);
	gtk_widget_set_tooltip_text ((GtkWidget*) self, _ ("Notes"));
	xfce_panel_plugin_menu_show_configure ((XfcePanelPlugin*) self);
	xfce_panel_plugin_menu_show_about ((XfcePanelPlugin*) self);
	mi = g_object_ref_sink ((GtkMenuItem*) gtk_menu_item_new_with_mnemonic (_ ("_Groups")));
	menu = xnp_application_context_menu (self->priv->application);
	gtk_menu_item_set_submenu (mi, (GtkWidget*) menu);
	gtk_widget_show_all ((GtkWidget*) mi);
	xfce_panel_plugin_menu_insert_item ((XfcePanelPlugin*) self, mi);
	notes_plugin_set_x_selection (self);
	g_signal_connect_object ((XfcePanelPlugin*) self, "size-changed", (GCallback) __lambda2__xfce_panel_plugin_size_changed, self, 0);
	g_signal_connect_object ((XfcePanelPlugin*) self, "save", (GCallback) __lambda3__xfce_panel_plugin_save, self, 0);
	g_signal_connect_object ((XfcePanelPlugin*) self, "free-data", (GCallback) __lambda4__xfce_panel_plugin_free_data, self, 0);
	g_signal_connect_object ((XfcePanelPlugin*) self, "configure-plugin", (GCallback) __lambda5__xfce_panel_plugin_configure_plugin, self, 0);
	g_signal_connect_object ((XfcePanelPlugin*) self, "about", (GCallback) __lambda6__xfce_panel_plugin_about, self, 0);
	g_signal_connect_object ((GtkObject*) self, "destroy", (GCallback) __lambda7__gtk_object_destroy, self, 0);
	_g_object_unref0 (mi);
	_g_object_unref0 (menu);
}


static gboolean _lambda1_ (GtkInvisible* w, GdkEventClient* event, NotesPlugin* self) {
	gboolean result;
	g_return_val_if_fail (w != NULL, FALSE);
	if (_vala_strcmp0 (popup_get_message_from_event (event), "SHOW_HIDE") == 0) {
		xnp_application_show_hide_notes (self->priv->application);
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}


static gboolean __lambda1__gtk_widget_client_event (GtkInvisible* _sender, GdkEventClient* event, gpointer self) {
	return _lambda1_ (_sender, event, self);
}


static gboolean notes_plugin_set_x_selection (NotesPlugin* self) {
	gboolean result;
	GtkInvisible* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	self->priv->invisible = (_tmp0_ = g_object_ref_sink ((GtkInvisible*) gtk_invisible_new ()), _g_object_unref0 (self->priv->invisible), _tmp0_);
	if (!popup_set_x_selection ((GtkWidget*) self->priv->invisible)) {
		result = FALSE;
		return result;
	}
	g_signal_connect_object ((GtkWidget*) self->priv->invisible, "client-event", (GCallback) __lambda1__gtk_widget_client_event, self, 0);
	result = TRUE;
	return result;
}


static void notes_plugin_class_init (NotesPluginClass * klass) {
	notes_plugin_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (NotesPluginPrivate));
	XFCE_PANEL_PLUGIN_CLASS (klass)->construct = notes_plugin_real_construct;
	G_OBJECT_CLASS (klass)->finalize = notes_plugin_finalize;
}


static void notes_plugin_instance_init (NotesPlugin * self) {
	self->priv = NOTES_PLUGIN_GET_PRIVATE (self);
}


static void notes_plugin_finalize (GObject* obj) {
	NotesPlugin * self;
	self = NOTES_PLUGIN (obj);
	_g_object_unref0 (self->priv->invisible);
	_g_object_unref0 (self->priv->button);
	_g_object_unref0 (self->priv->image);
	_g_object_unref0 (self->priv->application);
	G_OBJECT_CLASS (notes_plugin_parent_class)->finalize (obj);
}


GType notes_plugin_get_type (void) {
	return notes_plugin_type_id;
}


GType notes_plugin_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (NotesPluginClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) notes_plugin_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NotesPlugin), 0, (GInstanceInitFunc) notes_plugin_instance_init, NULL };
	notes_plugin_type_id = g_type_module_register_type (module, XFCE_TYPE_PANEL_PLUGIN, "NotesPlugin", &g_define_type_info, 0);
	return notes_plugin_type_id;
}


GType xfce_panel_module_init (GTypeModule* module) {
	GType result;
	g_return_val_if_fail (module != NULL, 0UL);
	notes_plugin_register_type (module);
	result = TYPE_NOTES_PLUGIN;
	return result;
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




